<template>
    <div>
        <div class="communal-list">
            <div class="communal-title">
                <div>酒店资料</div>
                <div class="communal-box">
                    <el-input @input="Inquireclick()" placeholder="城市/名称/联系人" v-model="input" clearable
                        style="width: 350px;">
                    </el-input>
                    <router-link to="/home/HotelDataOperation">
                        <el-button type="primary" style="margin-left: 10px;">新增</el-button>
                    </router-link>

                </div>
            </div>
            <template>
                <el-table :data="tableDatas.slice((currentPage - 1) * pageSize, currentPage * pageSize)" border
                    style="width: 100%" v-loading="loading" element-loading-text="拼命加载中...">
                    <el-table-column prop="num" label="序 号" width="55">
                        <template slot-scope="scope">
                            {{ (currentPage - 1) * pageSize + scope.$index + 1 }}
                        </template>
                    </el-table-column>
                    <el-table-column prop="city" label="所在城市" width="150">
                        <template slot-scope="scope">
                            {{scope.row.city|filter_emptyAcquiesce}}
                        </template>
                    </el-table-column>
                    <el-table-column prop="name" label="酒店名称" width="300">
                        <template slot-scope="scope">
                            {{scope.row.name|filter_emptyAcquiesce}}
                        </template>
                    </el-table-column>
                    <el-table-column prop="tel" label="酒店电话" width="200">
                        <template slot-scope="scope">
                            {{scope.row.tel|filter_emptyAcquiesce}}
                        </template>
                    </el-table-column>
                    <el-table-column prop="fax" label="酒店传真" width="180">
                        <template slot-scope="scope">
                            {{scope.row.fax|filter_emptyAcquiesce}}
                        </template>
                    </el-table-column>
                    <el-table-column prop="contact" label="联系人" width="180">
                        <template slot-scope="scope">
                            {{scope.row.contact|filter_emptyAcquiesce}}
                        </template>
                    </el-table-column>
                    <el-table-column prop="contactPhone" label="联系电话" width="200">
                        <template slot-scope="scope">
                            {{scope.row.contactPhone|filter_emptyAcquiesce}}
                        </template>
                    </el-table-column>
                    <el-table-column label="操作">
                        <template slot-scope="scope">
                            <el-button size="mini" @click="upDate(scope.$index, scope.row)">编辑</el-button>
                            <el-button size="mini" type="danger" @click="del(scope.$index, scope.row)">删除</el-button>
                        </template>
                    </el-table-column>
                </el-table>
            </template>
            <div class="block">
                <el-pagination align='center' @size-change="handleSizeChange" @current-change="handleCurrentChange"
                    :current-page="currentPage" :page-sizes="[10, 12, 15, 20]" :page-size="pageSize"
                    layout="total, sizes, prev, pager, next" :total="tableDatas.length">
                </el-pagination>
            </div>
        </div>
    </div>
</template>
<script>
export default {
    beforeRouteLeave(to, from, next) {
        if(to.name!='HotelDataOperation'){
            localStorage.removeItem('jdzlval');
        }
        next()
    },
    data() {
        return {
            loading: false,
            tableDatas: [],
            tableData: [],
            currentPage: 1, // 当前页码
            pageSize: 12,// 每页的数据条数
            input: '',
            token: '',
            userId: 0
        }
    },
    methods: {
        //每页条数改变时触发 选择一页显示多少行
        handleSizeChange(val) {
            this.currentPage = 1;
            this.pageSize = val;
        },
        //当前页改变时触发 跳转其他页
        handleCurrentChange(val) {
            this.currentPage = val;
        },
        HotelData() {
            this.loading = true
            var url = "/api/Resource/QueryHotelData"
            var that = this
            this.$axios({
                method: 'post',
                url: url,
                headers: {
                    Authorization: 'Bearer ' + this.token
                },
                data: {
                    portType: 1,
                    PageIndex: 0,
                    PageSize: 0,
                    City: '',
                    Name: '',
                    Contact: '',
                    ContactPhone: '',
                }
            }).then(function (res) {
                console.log(res)

                if (res.data.code == 200) {

                    that.tableData = res.data.data;
                    that.tableDatas = that.tableData;
                    if (that.tableDatas.slice((that.currentPage - 1) * that.pageSize, that.currentPage * that.pageSize).length == 0) {
                        if (that.currentPage > 1) {
                            that.currentPage = that.currentPage - 1;
                        }
                    }
                    if(JSON.parse(localStorage.getItem('jdzlval'))){
                        that.currentPage=JSON.parse(localStorage.getItem('jdzlval')).currentPage;
                        that.input=JSON.parse(localStorage.getItem('jdzlval')).input;
                        var newarr = [];
                        if (that.input == "") {
                            newarr = that.tableData;
                        } else {
                            for (var i = 0; i < that.tableData.length; i++) {
                                if (that.tableData[i].city.indexOf(that.input) != -1) {
                                    newarr.push(that.tableData[i]);
                                } else if (that.tableData[i].name.indexOf(that.input) != -1) {
                                    newarr.push(that.tableData[i]);
                                } else if (that.tableData[i].contact.indexOf(that.input) != -1) {
                                    newarr.push(that.tableData[i]);
                                }
                            }
                        }
                        that.tableDatas = newarr;
                    }
                }
                that.loading = false
            }).catch(function (error) {
                that.loading = false
                that.$message.error("上传oa,请稍等");
            });
        },
        //搜索框处理
        Inquireclick() {
            var newarr = [];
            if (this.input == "") {
                newarr = this.tableData;
            } else {

                for (var i = 0; i < this.tableData.length; i++) {
                    if (this.tableData[i].city.indexOf(this.input) != -1) {
                        newarr.push(this.tableData[i]);
                    } else if (this.tableData[i].name.indexOf(this.input) != -1) {
                        newarr.push(this.tableData[i]);
                    } else if (this.tableData[i].contact.indexOf(this.input) != -1) {
                        newarr.push(this.tableData[i]);
                    }
                }
            }

            this.tableDatas = newarr;
            this.currentPage = 1;
        },

        upDate(index, row) {
            var jdzlval={
                currentPage:this.currentPage,
                input:this.input,
            }
            localStorage.setItem('jdzlval', JSON.stringify(jdzlval));
            this.$router.push({
                path: "/home/HotelDataOperation",
                query: { id: row.id }
            })
        },

        del(index, row) {

            var url = "/api/Resource/DelHotelData"
            var that = this
            this.$axios({
                method: 'post',
                url: url,
                headers: {
                    Authorization: 'Bearer ' + this.token
                },
                data: {
                    Id: row.id,
                    DeleteUserId: this.userId
                }
            }).then(function (res) {
                console.log(res)

                if (res.data.code == 200) {

                    that.$message({
                        message: '删除成功',
                        type: 'success'
                    });
                    that.HotelData();
                } else {
                    that.$message.error('删除失败！');
                }
                that.loading = false
            }).catch(function (error) {
                that.loading = false
                that.$message.error("网络错误，请稍后重试");
            });
        }
    },
    created(){
        // if(JSON.parse(localStorage.getItem('jdzlval'))){
        //     this.currentPage=JSON.parse(localStorage.getItem('jdzlval')).currentPage;
        //     this.input=JSON.parse(localStorage.getItem('jdzlval')).input;
        //     var newarr = [];
        //     console.log(this.input);
        //     if (this.input == "") {
        //         console.log(1);
        //         newarr = this.tableData;
        //     } else {
        //         console.log(2);

        //         for (var i = 0; i < this.tableData.length; i++) {
        //             if (this.tableData[i].city.indexOf(this.input) != -1) {
        //                 newarr.push(this.tableData[i]);
        //             } else if (this.tableData[i].name.indexOf(this.input) != -1) {
        //                 newarr.push(this.tableData[i]);
        //             } else if (this.tableData[i].contact.indexOf(this.input) != -1) {
        //                 newarr.push(this.tableData[i]);
        //             }
        //         }
        //     }

        //     this.tableDatas = newarr;
        // }
    },
    filters:{
        //空默认值
        filter_emptyAcquiesce(value) {
            let fhz= value==""?"--":value
            return fhz
        },
    },
    mounted() {
        this.token = JSON.parse(localStorage.getItem('userinif')).token;
        this.userId = JSON.parse(localStorage.getItem('userinif')).userInfo.userId
        this.HotelData();
        
    }
}
</script>
<style>
.communal-list {
    background-color: #fff;
    padding: 10px;
    box-shadow: 0 0 5px #0005;
    border-radius: 10px;
}

.communal-title {
    display: flex;
    font-size: 17px;
    font-weight: 600;
    color: #555;
    margin-top: 8px;
    margin-bottom: 10px;
    justify-content: space-between;
    align-items: center;
}

.communal-box {
    display: flex;
}

.communal-box>button {
    margin-left: 10px;
    padding: 8px 20px;
}
</style>